#ifndef INSTANCE_H
#define INSTANCE_H

#include <stack>

class InstancesManager {
	static InstancesManager * singleton_;

	std::stack<void(*)()> destroy_funcs_;

	InstancesManager() {}
	~InstancesManager();
	InstancesManager(const InstancesManager&); // no copy
	InstancesManager & operator=(const InstancesManager&); // no copy
public:
	static InstancesManager & Instance();
	static void DestroyInstance();

	void Push(void(*pf)());
};

#endif
